Index: trunk/Mars/mbadpixels/MHBadPixels.cc
===================================================================
--- trunk/Mars/mbadpixels/MHBadPixels.cc	(revision 19302)
+++ trunk/Mars/mbadpixels/MHBadPixels.cc	(revision 19304)
@@ -60,5 +60,5 @@
     fBadId->SetDirectory(NULL);
     fBadId->UseCurrentStyle();
-    fBadId->SetXTitle("\\Theta [\\circ]");
+    fBadId->SetXTitle("\\Theta [#circ]");
     fBadId->SetYTitle("pixel Id");
     fBadId->SetTitleOffset(1.2, "Y");
@@ -69,5 +69,5 @@
     fBadN->SetDirectory(NULL);
     fBadN->UseCurrentStyle();
-    fBadN->SetXTitle("\\Theta [\\circ]");
+    fBadN->SetXTitle("\\Theta [#circ]");
     fBadN->SetYTitle("number of bad pixels");
     fBadN->SetTitleOffset(1.2, "Y");
Index: trunk/Mars/mhbase/MHn.cc
===================================================================
--- trunk/Mars/mhbase/MHn.cc	(revision 19302)
+++ trunk/Mars/mhbase/MHn.cc	(revision 19304)
@@ -118,5 +118,5 @@
 //    hres.AddHist("MPointingPos.fZd", "log10(MEnergyEst.fVal)-log10(MMcEvt.fEnergy)");
 //    hres.InitName("ResTheta;Theta;EnergyResidual");
-//    hres.InitTitle(";Zd [\\circ];\\Delta lg E;");
+//    hres.InitTitle(";Zd [#circ];\\Delta lg E;");
 //    hres.SetDrawOption("colz profx");
 //
Index: trunk/Mars/mhflux/MHAlpha.cc
===================================================================
--- trunk/Mars/mhflux/MHAlpha.cc	(revision 19302)
+++ trunk/Mars/mhflux/MHAlpha.cc	(revision 19304)
@@ -93,5 +93,5 @@
     fHist.SetXTitle("\\Theta [deg]");
     //fHist.SetYTitle("E_{est} [GeV]");
-    fHist.SetZTitle("|\\alpha| [\\circ]");
+    fHist.SetZTitle("|\\alpha| [#circ]");
     fHist.SetDirectory(NULL);
     fHist.UseCurrentStyle();
@@ -99,5 +99,5 @@
     // Main histogram
     fHistTime.SetName("Alpha");
-    fHistTime.SetXTitle("|\\alpha| [\\circ]");
+    fHistTime.SetXTitle("|\\alpha| [#circ]");
     fHistTime.SetYTitle("Counts");
     fHistTime.UseCurrentStyle();
@@ -113,5 +113,5 @@
     fHTheta.SetName("ExcessTheta");
     fHTheta.SetTitle(" N_{exc} vs. \\Theta ");
-    fHTheta.SetXTitle("\\Theta [\\circ]");
+    fHTheta.SetXTitle("\\Theta [#circ]");
     fHTheta.SetYTitle("N_{exc}");
     fHTheta.SetDirectory(NULL);
@@ -800,5 +800,5 @@
         h = (TH1D*)fHist.Project3D("x");
         h->SetBit(TH1::kNoTitle|TH1::kNoStats);
-        h->SetXTitle("\\theta [\\circ]");
+        h->SetXTitle("\\theta [#circ]");
         h->SetYTitle("Counts");
         h->SetDirectory(NULL);
Index: trunk/Mars/mhflux/MHCollectionArea.cc
===================================================================
--- trunk/Mars/mhflux/MHCollectionArea.cc	(revision 19302)
+++ trunk/Mars/mhflux/MHCollectionArea.cc	(revision 19304)
@@ -390,5 +390,5 @@
         /*
         h = fHistAll.ProjectionX("ProjAllX", -1, -1, "E");
-        h->SetXTitle("\\Theta [\\circ]");
+        h->SetXTitle("\\Theta [#circ]");
         h->SetDirectory(NULL);
         h->SetLineColor(kGreen);
@@ -397,5 +397,5 @@
         */
         h = fHistSel.ProjectionX("ProjSelX", -1, -1, "E");
-        h->SetXTitle("\\Theta [\\circ]");
+        h->SetXTitle("\\Theta [#circ]");
         h->SetDirectory(NULL);
         h->SetLineColor(kRed);
Index: trunk/Mars/mhflux/MHDisp.cc
===================================================================
--- trunk/Mars/mhflux/MHDisp.cc	(revision 19302)
+++ trunk/Mars/mhflux/MHDisp.cc	(revision 19304)
@@ -82,6 +82,6 @@
     fHist.SetName("Alpha");
     fHist.SetTitle("3D-plot of ThetaSq vs x, y");
-    fHist.SetXTitle("dx [\\circ]");
-    fHist.SetYTitle("dy [\\circ]");
+    fHist.SetXTitle("dx [#circ]");
+    fHist.SetYTitle("dy [#circ]");
     fHist.SetZTitle("Eq.cts");
 
@@ -624,5 +624,5 @@
             h2->Fit(&func, "IQ", "", 0, 1.0);
 
-            h2->SetTitle(MString::Format("P=(%.2f\\circ/%.2f\\circ) \\omega=%.2f\\circ f=%.2f",
+            h2->SetTitle(MString::Format("P=(%.2f#circ/%.2f#circ) \\omega=%.2f#circ f=%.2f",
                                          x0, y0, func.GetParameter(2), TMath::Abs(scale)));
         }
@@ -709,5 +709,5 @@
     //TH1F *h = new TH1F("RadProf", "Radial Profile", nbin, 0, maxr);
     //h->Sumw2();
-    h->SetXTitle("\\vartheta [\\circ]");
+    h->SetXTitle("\\vartheta [#circ]");
     h->SetYTitle("<cts>/\\Delta R");
     h->SetBit(kCanDelete);
Index: trunk/Mars/mhflux/MHEffectiveOnTime.cc
===================================================================
--- trunk/Mars/mhflux/MHEffectiveOnTime.cc	(revision 19302)
+++ trunk/Mars/mhflux/MHEffectiveOnTime.cc	(revision 19304)
@@ -318,5 +318,5 @@
     fH2DeltaT.SetName("DeltaT");
     fH2DeltaT.SetXTitle("\\Delta t [s]");
-    fH2DeltaT.SetYTitle("\\Theta [\\circ]");
+    fH2DeltaT.SetYTitle("\\Theta [#circ]");
     fH2DeltaT.SetZTitle("Count");
     fH2DeltaT.UseCurrentStyle();
@@ -333,5 +333,5 @@
     fHThetaEffOn.SetName("EffOnTheta");
     fHThetaEffOn.SetTitle("Effective On Time T_{eff}");
-    fHThetaEffOn.SetXTitle("\\Theta [\\circ]");
+    fHThetaEffOn.SetXTitle("\\Theta [#circ]");
     fHThetaEffOn.SetYTitle("T_{eff} [s]");
     fHThetaEffOn.UseCurrentStyle();
@@ -359,5 +359,5 @@
     fHThetaProb.SetName("ProbTheta");
     fHThetaProb.SetTitle("\\chi^{2} Probability of Fit");
-    fHThetaProb.SetXTitle("\\Theta [\\circ]");
+    fHThetaProb.SetXTitle("\\Theta [#circ]");
     fHThetaProb.SetYTitle("p [%]");
     fHThetaProb.UseCurrentStyle();
@@ -386,5 +386,5 @@
     fHThetaLambda.SetName("LambdaTheta");
     fHThetaLambda.SetTitle("Slope (Rate) vs Theta");
-    fHThetaLambda.SetXTitle("\\Theta [\\circ]");
+    fHThetaLambda.SetXTitle("\\Theta [#circ]");
     fHThetaLambda.SetYTitle("\\lambda [s^{-1}]");
     fHThetaLambda.UseCurrentStyle();
@@ -395,5 +395,5 @@
     fHTimeLambda.SetName("LambdaTime");
     fHTimeLambda.SetTitle("Slope (Rate) vs Time");
-    fHTimeLambda.SetXTitle("\\Time [\\circ]");
+    fHTimeLambda.SetXTitle("\\Time [#circ]");
     fHTimeLambda.SetYTitle("\\lambda [s^{-1}]");
     fHTimeLambda.UseCurrentStyle();
@@ -408,5 +408,5 @@
     fHThetaNDF.SetName("NDofTheta");
     fHThetaNDF.SetTitle("Number of Degrees of freedom vs Theta");
-    fHThetaNDF.SetXTitle("\\Theta [\\circ]");
+    fHThetaNDF.SetXTitle("\\Theta [#circ]");
     fHThetaNDF.SetYTitle("NDoF [#]");
     fHThetaNDF.UseCurrentStyle();
@@ -1038,6 +1038,6 @@
     gPad->SetBorderMode(0);
     h = fH2DeltaT.ProjectionY("ProjTheta"/*fNameProjTheta*/, -1, -1, "E");
-    h->SetTitle("Distribution of  \\Theta [\\circ]");
-    h->SetXTitle("\\Theta [\\circ]");
+    h->SetTitle("Distribution of  \\Theta [#circ]");
+    h->SetXTitle("\\Theta [#circ]");
     h->SetYTitle("Counts");
     h->SetDirectory(NULL);
Index: trunk/Mars/mhflux/MHEnergyEst.cc
===================================================================
--- trunk/Mars/mhflux/MHEnergyEst.cc	(revision 19302)
+++ trunk/Mars/mhflux/MHEnergyEst.cc	(revision 19304)
@@ -85,5 +85,5 @@
     fHEnergy.SetXTitle("E_{est} [GeV]");
     fHEnergy.SetYTitle("E_{mc} [GeV]");
-    fHEnergy.SetZTitle("\\Theta [\\circ]");
+    fHEnergy.SetZTitle("\\Theta [#circ]");
 
     fHResolutionEst.SetDirectory(NULL);
Index: trunk/Mars/mhflux/MHFalseSource.cc
===================================================================
--- trunk/Mars/mhflux/MHFalseSource.cc	(revision 19302)
+++ trunk/Mars/mhflux/MHFalseSource.cc	(revision 19304)
@@ -174,7 +174,7 @@
     fHist.SetName("Alpha");
     fHist.SetTitle("3D-plot of Alpha vs x, y");
-    fHist.SetXTitle("x [\\circ]");
-    fHist.SetYTitle("y [\\circ]");
-    fHist.SetZTitle("\\alpha [\\circ]");
+    fHist.SetXTitle("x [#circ]");
+    fHist.SetYTitle("y [#circ]");
+    fHist.SetZTitle("\\alpha [#circ]");
 }
 
@@ -407,5 +407,5 @@
     const Float_t cut1 = axe.GetBinLowEdge(f);
     const Float_t cut2 = axe.GetBinUpEdge(l);
-    h2->SetTitle(MString::Format("Distribution of %.1f\\circ<|\\alpha|<%.1f\\circ in x,y", cut1, cut2));
+    h2->SetTitle(MString::Format("Distribution of %.1f#circ<|\\alpha|<%.1f#circ in x,y", cut1, cut2));
 
     // Get projection for range
@@ -444,5 +444,5 @@
     axe.SetRangeUser(0, fAlphaCut);
     const Float_t cut = axe.GetBinUpEdge(axe.GetLast());
-    h3->SetTitle(MString::Format("Distribution of |\\alpha|<%.1f\\circ in x,y", cut));
+    h3->SetTitle(MString::Format("Distribution of |\\alpha|<%.1f#circ in x,y", cut));
 
     // Get projection for range
@@ -932,5 +932,5 @@
     histb->Reset();
     hist->SetNameTitle("Significance",
-                       MString::Format("Fit Region: Signal<%.1f\\circ, %.1f\\circ<Bg<%.1f\\circ",
+                       MString::Format("Fit Region: Signal<%.1f#circ, %.1f#circ<Bg<%.1f#circ",
                                        sigmax, bgmin, bgmax));
     hists->SetName("Excess");
@@ -1050,6 +1050,6 @@
     h0b.GetXaxis()->SetRangeUser(0, maxalpha0*1.5);
 
-    hists->SetTitle(MString::Format("Excess events for \\alpha<%.0f\\circ (N_{max}=%d)", sigint, (int)hists->GetMaximum()));
-    histb->SetTitle(MString::Format("Background events for \\alpha<%.0f\\circ", sigint));
+    hists->SetTitle(MString::Format("Excess events for \\alpha<%.0f#circ (N_{max}=%d)", sigint, (int)hists->GetMaximum()));
+    histb->SetTitle(MString::Format("Background events for \\alpha<%.0f#circ", sigint));
 
     //hists->SetMinimum(GetMinimumGT(*hists));
@@ -1150,5 +1150,5 @@
         h->SetNameTitle("Result \\alpha", title);
         h->SetBit(kCanDelete);
-        h->SetXTitle("\\alpha [\\circ]");
+        h->SetXTitle("\\alpha [#circ]");
         h->SetYTitle("Counts");
         h->Draw();
@@ -1167,5 +1167,5 @@
             hof->SetNameTitle("Result \\alpha", title);
             hof->SetBit(kCanDelete);
-            hof->SetXTitle("\\alpha [\\circ]");
+            hof->SetXTitle("\\alpha [#circ]");
             hof->SetYTitle("Counts");
             hof->Draw("same");
@@ -1176,5 +1176,5 @@
             diff->SetNameTitle("Result On-Off \\alpha", title);
             diff->SetBit(kCanDelete);
-            diff->SetXTitle("\\alpha [\\circ]");
+            diff->SetXTitle("\\alpha [#circ]");
             diff->SetYTitle("Counts");
             diff->Draw("same");
@@ -1239,5 +1239,5 @@
 
         g->SetNameTitle("SigVs\\alpha", "Significance vs \\alpha");
-        g->GetHistogram()->SetXTitle("\\alpha_{0} [\\circ]");
+        g->GetHistogram()->SetXTitle("\\alpha_{0} [#circ]");
         g->GetHistogram()->SetYTitle("Significance");
         g->SetBit(kCanDelete);
@@ -1247,5 +1247,5 @@
         leg->SetBorderSize(1);
         leg->SetTextSize(0.1);
-        leg->AddText(MString::Format("S_{max}=%.1f\\sigma at \\alpha_{max}=%d\\circ", maxsig, max));
+        leg->AddText(MString::Format("S_{max}=%.1f\\sigma at \\alpha_{max}=%d#circ", maxsig, max));
         leg->SetBit(kCanDelete);
         leg->Draw();
@@ -1420,6 +1420,6 @@
      tex.SetTextAlign(21);
      tex.SetTextSize(0.04);
-     tex.DrawLatex(-0.79, -0.8, "43.0\\circ");
-     tex.DrawLatex(-0.78,  0.2, "42.0\\circ");
+     tex.DrawLatex(-0.79, -0.8, "43.0#circ");
+     tex.DrawLatex(-0.78,  0.2, "42.0#circ");
 
      tex.SetTextAngle(-90);
Index: trunk/Mars/mhflux/MHPhi.cc
===================================================================
--- trunk/Mars/mhflux/MHPhi.cc	(revision 19302)
+++ trunk/Mars/mhflux/MHPhi.cc	(revision 19304)
@@ -86,5 +86,5 @@
     // Init Graphs
     fHPhi.SetNameTitle("Phi", "\\Delta\\Phi-Distribution");
-    fHPhi.SetXTitle("\\Delta\\Phi' [\\circ]");
+    fHPhi.SetXTitle("\\Delta\\Phi' [#circ]");
     fHPhi.SetYTitle("Counts");
 
@@ -111,5 +111,5 @@
 
     fHInhom.SetNameTitle("Inhomogeneity", "\\Delta\\Phi-Distribution");
-    fHInhom.SetXTitle("\\Delta\\Phi' [\\circ]");
+    fHInhom.SetXTitle("\\Delta\\Phi' [#circ]");
     fHInhom.SetYTitle("Counts");
     fHInhom.Sumw2();
@@ -432,5 +432,5 @@
     const Double_t S    = MMath::SignificanceLiMaSigned(sig,  bg, f);
 
-    const TString fmt = Form("\\sigma_{L/M}=%.1f (\\sigma_{0}=%.1f)  \\Delta\\Phi_{on}<%.1f\\circ  E=%.0f  B=%.0f  f=%.2f",
+    const TString fmt = Form("\\sigma_{L/M}=%.1f (\\sigma_{0}=%.1f)  \\Delta\\Phi_{on}<%.1f#circ  E=%.0f  B=%.0f  f=%.2f",
                              S, S0, cut, sig-bg*f, bg*f, f);
 
Index: trunk/Mars/mhist/MHCamEventRot.cc
===================================================================
--- trunk/Mars/mhist/MHCamEventRot.cc	(revision 19302)
+++ trunk/Mars/mhist/MHCamEventRot.cc	(revision 19304)
@@ -161,6 +161,6 @@
         {
             fHist.SetTitle(fTitle);
-            fHist.SetXTitle("x [\\circ]");
-            fHist.SetYTitle("y [\\circ]");
+            fHist.SetXTitle("x [#circ]");
+            fHist.SetYTitle("y [#circ]");
         }
         else
Index: trunk/Mars/mhist/MHCamera.cc
===================================================================
--- trunk/Mars/mhist/MHCamera.cc	(revision 19302)
+++ trunk/Mars/mhist/MHCamera.cc	(revision 19304)
@@ -1963,5 +1963,5 @@
         newtxt2.PaintText(-range*.95, -range*.95, text);
 
-        text = MString::Format("%.2f\\circ", range*(0.99-0.60)*fGeomCam->GetConvMm2Deg());
+        text = MString::Format("%.2f#circ", range*(0.99-0.60)*fGeomCam->GetConvMm2Deg());
         text = text.Strip(TString::kLeading);
 
Index: trunk/Mars/mhist/MHFindSignificance.cc
===================================================================
--- trunk/Mars/mhist/MHFindSignificance.cc	(revision 19302)
+++ trunk/Mars/mhist/MHFindSignificance.cc	(revision 19304)
@@ -364,5 +364,5 @@
   fHist->Sumw2();
   //fHist->SetNameTitle("Alpha", "alpha plot");
-  fHist->SetXTitle("|alpha|  [\\circ]");
+  fHist->SetXTitle("|alpha|  [#circ]");
   fHist->SetYTitle("Counts");
   fHist->UseCurrentStyle();
@@ -508,5 +508,5 @@
   fHist->Sumw2();
   //fHist->SetNameTitle("alpha", "alpha plot");
-  fHist->SetXTitle("|alpha|  [\\circ]");
+  fHist->SetXTitle("|alpha|  [#circ]");
   fHist->SetYTitle("Counts");
   fHist->UseCurrentStyle();
@@ -537,5 +537,5 @@
 
   fSigVsAlpha = new TH1D("SigVsAlpha","Sigma vs Alpha", nsteps, 0.0, alphamin);
-  fSigVsAlpha->SetXTitle("upper edge of signal region in |alpha|  [\\circ]");
+  fSigVsAlpha->SetXTitle("upper edge of signal region in |alpha|  [#circ]");
   fSigVsAlpha->SetYTitle("Significance of gamma signal");
 
@@ -781,5 +781,5 @@
   }
 
-  fHist->SetXTitle("|alpha|  [\\circ]");
+  fHist->SetXTitle("|alpha|  [#circ]");
   fHist->SetYTitle("Counts");
 
@@ -1805,5 +1805,5 @@
     t1->SetTextColor(2);
 
-    sprintf(tx, "   (%6.2f< |alpha| <%6.2f [\\circ])", fAlphami, fAlphama);
+    sprintf(tx, "   (%6.2f< |alpha| <%6.2f [#circ])", fAlphami, fAlphama);
     pt->AddText(tx);
 
@@ -1824,5 +1824,5 @@
 
     //--------------
-    sprintf(tx, "Results for |alpha|< %6.2f [\\circ] :", fAlphasi);
+    sprintf(tx, "Results for |alpha|< %6.2f [#circ] :", fAlphasi);
     TText *t6 = pt->AddText(tx);
     t6->SetTextSize(0.03);
@@ -1859,5 +1859,5 @@
       pt->AddText(tx);
 
-      sprintf(tx, "   Sigma of Gauss = %8.1f #pm %8.1f  [\\circ]", 
+      sprintf(tx, "   Sigma of Gauss = %8.1f #pm %8.1f  [#circ]", 
               fSigmaGauss, fdSigmaGauss);
       pt->AddText(tx);
Index: trunk/Mars/mhist/MHRate.cc
===================================================================
--- trunk/Mars/mhist/MHRate.cc	(revision 19302)
+++ trunk/Mars/mhist/MHRate.cc	(revision 19304)
@@ -90,5 +90,5 @@
     InitGraph(fRateTime);
 
-    fRateZd.SetXTitle("Zd [\\circ]");
+    fRateZd.SetXTitle("Zd [#circ]");
     fRateZd.SetYTitle("Rate [Hz]");
 
@@ -272,5 +272,5 @@
     //fHumidity.Draw("AP");
     //fTemperature.Draw("P");
-    //DrawRightAxis("T [\\circ C]");
+    //DrawRightAxis("T [#circ C]");
 
     pad->cd(2);
Index: trunk/Mars/mhist/MHStarMap.cc
===================================================================
--- trunk/Mars/mhist/MHStarMap.cc	(revision 19302)
+++ trunk/Mars/mhist/MHStarMap.cc	(revision 19304)
@@ -132,6 +132,6 @@
         fUseMmScale = kFALSE;
 
-        fStarMap->SetXTitle("x [\\circ]");
-        fStarMap->SetYTitle("y [\\circ]");
+        fStarMap->SetXTitle("x [#circ]");
+        fStarMap->SetYTitle("y [#circ]");
     }
 
@@ -307,6 +307,6 @@
     else
     {
-        fStarMap->SetXTitle("x [\\circ]");
-        fStarMap->SetYTitle("y [\\circ]");
+        fStarMap->SetXTitle("x [#circ]");
+        fStarMap->SetYTitle("y [#circ]");
 
         fStarMap->Scale(1./fMm2Deg);
Index: trunk/Mars/mhist/MHWeather.cc
===================================================================
--- trunk/Mars/mhist/MHWeather.cc	(revision 19302)
+++ trunk/Mars/mhist/MHWeather.cc	(revision 19304)
@@ -329,9 +329,9 @@
 
     DrawGraph(fHumidity,    "Humidity [%]");
-    DrawGraph(fTemperature, "T [\\circ C]");
+    DrawGraph(fTemperature, "T [#circ C]");
     DrawGraph(fWindSpeed,   "km/h");
     DrawGraph(fEventRate,   "f [Hz]");
     DrawGraph(fCloudiness,  "Cloudiness [%]");
-    DrawGraph(fTempAir,     "T [\\circ C]");
+    DrawGraph(fTempAir,     "T [#circ C]");
     DrawGraph(fTempSky,     "T_{sky}-200 [K]");
 
Index: trunk/Mars/mimage/MHHillas.cc
===================================================================
--- trunk/Mars/mimage/MHHillas.cc	(revision 19302)
+++ trunk/Mars/mimage/MHHillas.cc	(revision 19304)
@@ -86,8 +86,8 @@
     fDelta->SetDirectory(NULL);
 
-    fLength->SetXTitle("Length [\\circ]");
-    fWidth->SetXTitle("Width [\\circ]");
-    fDistC->SetXTitle("Distance [\\circ]");
-    fDelta->SetXTitle("Delta [\\circ]");
+    fLength->SetXTitle("Length [#circ]");
+    fWidth->SetXTitle("Width [#circ]");
+    fDistC->SetXTitle("Distance [#circ]");
+    fDelta->SetXTitle("Delta [#circ]");
 
     fLength->SetYTitle("Counts");
Index: trunk/Mars/mimage/MHHillasExt.cc
===================================================================
--- trunk/Mars/mimage/MHHillasExt.cc	(revision 19302)
+++ trunk/Mars/mimage/MHHillasExt.cc	(revision 19304)
@@ -117,8 +117,8 @@
     fHSlopeSpreadW.SetTitle("Weighted time spread around slope");
 
-    fHAsym.SetXTitle("Asym [\\circ]");
-    fHM3Long.SetXTitle("3^{rd} M_{l} [\\circ]");
-    fHM3Trans.SetXTitle("3^{rd} M_{t} [\\circ]");
-    fHSlopeL.SetXTitle("D [\\circ]");
+    fHAsym.SetXTitle("Asym [#circ]");
+    fHM3Long.SetXTitle("3^{rd} M_{l} [#circ]");
+    fHM3Trans.SetXTitle("3^{rd} M_{t} [#circ]");
+    fHSlopeL.SetXTitle("D [#circ]");
     fHTimeSpread.SetXTitle("T_{rms} [ns]");
     fHTimeSpreadW.SetXTitle("T_{rms} [ns]");
@@ -129,5 +129,5 @@
     fHM3Long.SetYTitle("Counts");
     fHM3Trans.SetYTitle("Counts");
-    fHSlopeL.SetYTitle("S_{l} [ns/\\circ]");
+    fHSlopeL.SetYTitle("S_{l} [ns/#circ]");
     fHTimeSpread.SetYTitle("Counts");
     fHTimeSpreadW.SetYTitle("Counts");
Index: trunk/Mars/mimage/MHNewImagePar.cc
===================================================================
--- trunk/Mars/mimage/MHNewImagePar.cc	(revision 19302)
+++ trunk/Mars/mimage/MHNewImagePar.cc	(revision 19304)
@@ -109,5 +109,5 @@
     fHistUsedArea.SetName("UsedArea");
     fHistUsedArea.SetTitle("Area of used pixels");
-    fHistUsedArea.SetXTitle("Area [\\circ^{2}]");
+    fHistUsedArea.SetXTitle("Area [#circ^{2}]");
     fHistUsedArea.SetYTitle("Counts");
     fHistUsedArea.SetDirectory(NULL);
@@ -118,5 +118,5 @@
     fHistCoreArea.SetName("CoreArea");
     fHistCoreArea.SetTitle("Area of core pixels");
-    fHistCoreArea.SetXTitle("Area [\\circ^{2}]");
+    fHistCoreArea.SetXTitle("Area [#circ^{2}]");
     fHistCoreArea.SetYTitle("Counts");
     fHistCoreArea.SetDirectory(NULL);
Index: trunk/Mars/mimage/MHVsSize.cc
===================================================================
--- trunk/Mars/mimage/MHVsSize.cc	(revision 19302)
+++ trunk/Mars/mimage/MHVsSize.cc	(revision 19304)
@@ -93,10 +93,10 @@
     fM3Long.SetXTitle("Size [phe]");
 
-    fLength.SetYTitle("Length [\\circ]");
-    fWidth.SetYTitle("Width [\\circ]");
-    fDist.SetYTitle("Distance [\\circ]");
+    fLength.SetYTitle("Length [#circ]");
+    fWidth.SetYTitle("Width [#circ]");
+    fDist.SetYTitle("Distance [#circ]");
     fConc1.SetYTitle("Conc1 [ratio]");
-    fArea.SetYTitle("Area [\\circ^{2}]");
-    fM3Long.SetYTitle("M3Long [\\circ]");
+    fArea.SetYTitle("Area [#circ^{2}]");
+    fM3Long.SetYTitle("M3Long [#circ]");
 
     const MBinning binse( 50,   10, 1e5, "", "log");
Index: trunk/Mars/mmuon/MHMuonPar.cc
===================================================================
--- trunk/Mars/mmuon/MHMuonPar.cc	(revision 19302)
+++ trunk/Mars/mmuon/MHMuonPar.cc	(revision 19304)
@@ -88,5 +88,5 @@
     fHistRadius.SetName("Radius");
     fHistRadius.SetTitle("Distribution of Radius'");
-    fHistRadius.SetXTitle("R [\\circ]");
+    fHistRadius.SetXTitle("R [#circ]");
     fHistRadius.SetYTitle("Counts");
     fHistRadius.GetXaxis()->SetTitleOffset(1.2);
@@ -97,5 +97,5 @@
     fHistArcWidth.SetName("ArcWidth");
     fHistArcWidth.SetTitle("Distribution of ArcWidth");
-    fHistArcWidth.SetXTitle("W [\\circ]");
+    fHistArcWidth.SetXTitle("W [#circ]");
     fHistArcWidth.GetXaxis()->SetTitleOffset(1.2);
     fHistArcWidth.SetYTitle("Counts");
@@ -106,5 +106,5 @@
     fHistBroad.SetName("RingBroadening");
     fHistBroad.SetTitle("Profile ArcWidth vs Radius");
-    fHistBroad.SetXTitle("R [\\circ]");
+    fHistBroad.SetXTitle("R [#circ]");
     fHistBroad.SetYTitle("W/R [1]");
     fHistBroad.GetXaxis()->SetTitleOffset(1.2);
@@ -115,5 +115,5 @@
     fHistSize.SetName("SizeVsRadius");
     fHistSize.SetTitle("Profile MuonSize vs Radius");
-    fHistSize.SetXTitle("R [\\circ]");
+    fHistSize.SetXTitle("R [#circ]");
     fHistSize.SetYTitle("S [phe]");
     fHistSize.GetXaxis()->SetTitleOffset(1.2);
@@ -287,5 +287,5 @@
     if (TString(opt)==TString("pad4"))
     {
-        const TString txt = MString::Format("\\Sigma_{%.2f\\circ}^{%.2f\\circ} = %.3f",
+        const TString txt = MString::Format("\\Sigma_{%.2f#circ}^{%.2f#circ} = %.3f",
                                             fgIntegralLoLim, fgIntegralUpLim, Integral(fHistBroad));
 
@@ -298,5 +298,5 @@
     if (TString(opt)==TString("pad3"))
     {
-        const TString txt = MString::Format("\\Sigma_{%.2f\\circ}^{%.2f\\circ} = %.f",
+        const TString txt = MString::Format("\\Sigma_{%.2f#circ}^{%.2f#circ} = %.f",
                                             fgIntegralLoLim, fgIntegralUpLim, Integral(fHistSize));
 
Index: trunk/Mars/mmuon/MHSingleMuon.cc
===================================================================
--- trunk/Mars/mmuon/MHSingleMuon.cc	(revision 19302)
+++ trunk/Mars/mmuon/MHSingleMuon.cc	(revision 19304)
@@ -117,5 +117,5 @@
     fHistPhi.SetName("HistPhi");
     fHistPhi.SetTitle("HistPhi");
-    fHistPhi.SetXTitle("\\phi [\\circ]");
+    fHistPhi.SetXTitle("\\phi [#circ]");
     fHistPhi.SetYTitle("sum of ADC");
     fHistPhi.SetDirectory(NULL);
@@ -125,5 +125,5 @@
     fHistWidth.SetName("HistWidth");
     fHistWidth.SetTitle("HistWidth");
-    fHistWidth.SetXTitle("distance from the ring center [\\circ]");
+    fHistWidth.SetXTitle("distance from the ring center [#circ]");
     fHistWidth.SetYTitle("sum of ADC");
     fHistWidth.SetDirectory(NULL);
Index: trunk/Mars/mpointing/MHPointing.cc
===================================================================
--- trunk/Mars/mpointing/MHPointing.cc	(revision 19302)
+++ trunk/Mars/mpointing/MHPointing.cc	(revision 19304)
@@ -322,5 +322,5 @@
     fPosZd.Draw("AP");
     //fPosAz.Draw("P");
-    //DrawRightAxis("Az [\\circ]");
+    //DrawRightAxis("Az [#circ]");
 }
 
@@ -356,6 +356,6 @@
     DrawGraph(fDevZd,       "\\Delta [arcmin]");
     DrawGraph(fDevAz,       "\\Delta [arcmin]");
-    DrawGraph(fPosZd,       "Zd [\\circ]");
-    //DrawGraph(fPosAz,       "Az [\\circ]");
+    DrawGraph(fPosZd,       "Zd [#circ]");
+    //DrawGraph(fPosAz,       "Az [#circ]");
 
     TVirtualPad *pad = gPad;
Index: trunk/Mars/mpointing/MHSrcPosCam.cc
===================================================================
--- trunk/Mars/mpointing/MHSrcPosCam.cc	(revision 19302)
+++ trunk/Mars/mpointing/MHSrcPosCam.cc	(revision 19304)
@@ -69,6 +69,6 @@
     fHist.SetName("SourcePos");
     fHist.SetTitle("Source position distribution in camera coordinates");
-    fHist.SetXTitle("dx [\\circ]");
-    fHist.SetYTitle("dy [\\circ]");
+    fHist.SetXTitle("dx [#circ]");
+    fHist.SetYTitle("dy [#circ]");
     fHist.SetZTitle("T_{eff} [s]");
     fHist.SetDirectory(NULL);
Index: trunk/Mars/mreflector/MHReflector.cc
===================================================================
--- trunk/Mars/mreflector/MHReflector.cc	(revision 19302)
+++ trunk/Mars/mreflector/MHReflector.cc	(revision 19304)
@@ -62,6 +62,6 @@
     fHistXY.SetName("ReflXY");
     fHistXY.SetTitle("Histogram vs X/Y and Energy");
-    fHistXY.SetXTitle("X [\\circ]");
-    fHistXY.SetYTitle("Y [\\circ]");
+    fHistXY.SetXTitle("X [#circ]");
+    fHistXY.SetYTitle("Y [#circ]");
     fHistXY.SetZTitle("E [GeV]");
     fHistXY.SetDirectory(NULL);
@@ -71,5 +71,5 @@
     fHistRad.SetTitle("Histogram vs Radius and Energy");
     fHistRad.SetXTitle("E [GeV]");
-    fHistRad.SetYTitle("R [\\circ]");
+    fHistRad.SetYTitle("R [#circ]");
     fHistRad.SetZTitle("Cnts/deg^{2}");
     fHistRad.SetDirectory(NULL);