Index: trunk/Mars/mjtrain/MJTrainDisp.cc
===================================================================
--- trunk/Mars/mjtrain/MJTrainDisp.cc	(revision 19007)
+++ trunk/Mars/mjtrain/MJTrainDisp.cc	(revision 19305)
@@ -387,17 +387,17 @@
     hres1.AddHist("MHillas.fSize", res);
     hres1.InitName("ResSize;Size;ResidualDist");
-    hres1.InitTitle(";S [phe];Disp-Dist [\\circ];");
+    hres1.InitTitle(";S [phe];Disp-Dist [#circ];");
     hres1.SetDrawOption("colz profx");
     hres1.AddHist("MHillasExt.fSlopeLong*sign(MHillasSrc.fCosDeltaAlpha)/MGeomCam.fConvMm2Deg", res);
     hres1.InitName("ResSlope;Slope;ResidualDist");
-    hres1.InitTitle(";Slope;Disp-Dist [\\circ];");
+    hres1.InitTitle(";Slope;Disp-Dist [#circ];");
     hres1.SetDrawOption("colz profx");
     hres1.AddHist("MNewImagePar.fLeakage1", res);
     hres1.InitName("ResLeak;Leakage;ResidualDist");
-    hres1.InitTitle(";Leak;Disp-Dist [\\circ];");
+    hres1.InitTitle(";Leak;Disp-Dist [#circ];");
     hres1.SetDrawOption("colz profx");
     hres1.AddHist("MPointingPos.fZd", res);
     hres1.InitName("ResTheta;Theta;ResidualDist");
-    hres1.InitTitle(";Zd [\\circ];Disp-Dist [\\circ];");
+    hres1.InitTitle(";Zd [#circ];Disp-Dist [#circ];");
     hres1.SetDrawOption("colz profx");
 
@@ -405,17 +405,17 @@
     hres2.AddHist("MHillas.fLength*MGeomCam.fConvMm2Deg", res);
     hres2.InitName("ResLength;Length;ResidualDist");
-    hres2.InitTitle(";L [\\circ];Disp-Dist [\\circ];");
+    hres2.InitTitle(";L [#circ];Disp-Dist [#circ];");
     hres2.SetDrawOption("colz profx");
     hres2.AddHist("MNewImagePar.fConc1", res);
     hres2.InitName("ResConc1;Conc;ResidualDist");
-    hres2.InitTitle(";C;Disp-Dist [\\circ];");
+    hres2.InitTitle(";C;Disp-Dist [#circ];");
     hres2.SetDrawOption("colz profx");
     hres2.AddHist("MHillas.fWidth*MGeomCam.fConvMm2Deg", res);
     hres2.InitName("ResWidth;Width;ResidualDist");
-    hres2.InitTitle(";W [\\circ];Disp-Dist [\\circ];");
+    hres2.InitTitle(";W [#circ];Disp-Dist [#circ];");
     hres2.SetDrawOption("colz profx");
     hres2.AddHist("MMcEvt.fEnergy", res);
     hres2.InitName("ResEmc;Energy;ResidualDist");
-    hres2.InitTitle(";E_{mc} [GeV];Disp-Dist [\\circ];");
+    hres2.InitTitle(";E_{mc} [GeV];Disp-Dist [#circ];");
     hres2.SetDrawOption("colz profx");
 
@@ -424,6 +424,6 @@
     hdisp1.SetName("Size;Size;ThetaSq");
     hdisp2.SetName("Energy;Energy;ThetaSq");
-    hdisp1.SetTitle("\\vartheta distribution vs. Size:Size [phe]:\\vartheta^2 [\\circ]");
-    hdisp2.SetTitle("\\vartheta distribution vs. Energy:Energy [GeV]:\\vartheta^2 [\\circ]");
+    hdisp1.SetTitle("\\vartheta distribution vs. Size:Size [phe]:\\vartheta^2 [#circ]");
+    hdisp2.SetTitle("\\vartheta distribution vs. Energy:Energy [GeV]:\\vartheta^2 [#circ]");
 
     // -------------- Setup fill tasks ----------------
Index: trunk/Mars/mjtrain/MJTrainEnergy.cc
===================================================================
--- trunk/Mars/mjtrain/MJTrainEnergy.cc	(revision 19007)
+++ trunk/Mars/mjtrain/MJTrainEnergy.cc	(revision 19305)
@@ -233,5 +233,5 @@
     hres1.AddHist("MHillasSrc.fDist*MGeomCam.fConvMm2Deg", res);
     hres1.InitName("ResDist;Dist;EnergyResidual");
-    hres1.InitTitle(";D [\\circ];\\Delta lg E;");
+    hres1.InitTitle(";D [#circ];\\Delta lg E;");
     hres1.SetDrawOption("colz profx");
 
@@ -244,5 +244,5 @@
     hres2.AddHist("MPointingPos.fZd", res);
     hres2.InitName("ResTheta;Theta;EnergyResidual");
-    hres2.InitTitle(";Zd [\\circ];\\Delta lg E;");
+    hres2.InitTitle(";Zd [#circ];\\Delta lg E;");
     hres2.SetDrawOption("colz profx");
     hres2.AddHist("MEnergyEst.fVal", res);
@@ -274,5 +274,5 @@
     hres3.AddHist("MPointingPos.fZd", "(MMcEvt.fEnergy/MEnergyEst.fVal-1)^2", MH3::kProfile);
     hres3.InitName("ResTheta;Theta;");
-    hres3.InitTitle(";\\Theta [\\circ];Resolution   \\sqrt{<(E_{mc}/E_{est}-1)^{2}>};");
+    hres3.InitTitle(";\\Theta [#circ];Resolution   \\sqrt{<(E_{mc}/E_{est}-1)^{2}>};");
     hres3.SetConversion("sqrt(x)");
 
Index: trunk/Mars/mjtrain/MJTrainImpact.cc
===================================================================
--- trunk/Mars/mjtrain/MJTrainImpact.cc	(revision 19007)
+++ trunk/Mars/mjtrain/MJTrainImpact.cc	(revision 19305)
@@ -233,5 +233,5 @@
     hres1.AddHist("MHillasSrc.fDist*MGeomCam.fConvMm2Deg", res);
     hres1.InitName("ResDist;Dist;ImpactResidual");
-    hres1.InitTitle(";D [\\circ];\\Delta I;");
+    hres1.InitTitle(";D [#circ];\\Delta I;");
     hres1.SetDrawOption("colz profx");
 
@@ -244,5 +244,5 @@
     hres2.AddHist("MPointingPos.fZd", res);
     hres2.InitName("ResTheta;Theta;ImpactResidual");
-    hres2.InitTitle(";Zd [\\circ];\\Delta I;");
+    hres2.InitTitle(";Zd [#circ];\\Delta I;");
     hres2.SetDrawOption("colz profx");
     hres2.AddHist("MImpactEst.fVal/100", res);
@@ -279,5 +279,5 @@
     hres3.AddHist("MPointingPos.fZd", "(MMcEvt.fImpact/MImpactEst.fVal-1)^2", MH3::kProfile);
     hres3.InitName("ResTheta;Theta;");
-    hres3.InitTitle(";\\Theta [\\circ];Resolution   \\sqrt{<(I_{mc}/I_{est}-1)^{2}>};");
+    hres3.InitTitle(";\\Theta [#circ];Resolution   \\sqrt{<(I_{mc}/I_{est}-1)^{2}>};");
     hres3.SetConversion("sqrt(x)");
 
Index: trunk/Mars/mjtrain/MJTrainSeparation.cc
===================================================================
--- trunk/Mars/mjtrain/MJTrainSeparation.cc	(revision 19007)
+++ trunk/Mars/mjtrain/MJTrainSeparation.cc	(revision 19305)
@@ -375,5 +375,5 @@
     {
         h.SetNameTitle("ThetaEMC", "Event-Distribution vs Theta and Energy for MC (produced)");
-        h.SetXTitle("\\Theta [\\circ]");
+        h.SetXTitle("\\Theta [#circ]");
         h.SetYTitle("E [GeV]");
         h.SetZTitle("Counts");
@@ -383,5 +383,5 @@
     {
         h.SetNameTitle("ThetaMC", "Event-Distribution vs Theta for MC (produced)");
-        h.SetXTitle("\\Theta [\\circ]");
+        h.SetXTitle("\\Theta [#circ]");
         h.SetYTitle("Counts");
         chain.Draw("MMcEvtBasic.fTelescopeTheta*TMath::RadToDeg()>>ThetaMC", w, "goff");